/// <reference types="react" />
import { ILocation, IModal, IPartialLocation, RouterAction } from 'react-native-stack';
import { ActionType as TSActionType } from 'typesafe-actions';
export declare enum InternalAppActionType {
    ROUTER_LOCATION_CHANGE = "@@router/ROUTER_LOCATION_CHANGE"
}
export declare enum AppActionType {
    SWITCH_TAB = "@@router/SWITCH_TAB",
    PUSH = "@@router/PUSH",
    GO = "@@router/GO",
    RESET = "@@router/RESET",
    GO_BACK = "@@router/GO_BACK",
    GO_FORWARD = "@@router/GO_FORWARD",
    REPLACE = "@@router/REPLACE",
    ADD_MODAL = "@@router/ADD_MODAL",
    REMOVE_MODAL = "@@router/REMOVE_MODAL"
}
export declare const routerLocationChange: (routerKey: string, action: RouterAction, index: number, entries: ILocation<any>[], length: number, location: ILocation<any>, callback?: (() => any) | undefined) => {
    type: InternalAppActionType;
    payload: {
        routerKey: string;
        action: RouterAction;
        index: number;
        entries: ILocation<any>[];
        length: number;
        location: ILocation<any>;
    };
    meta: {
        callback: (() => any) | undefined;
    };
};
export declare const switchTab: (location: string | IPartialLocation<any>, callback?: (() => any) | undefined) => {
    type: AppActionType.SWITCH_TAB;
    payload: {
        location: string | IPartialLocation<any>;
    };
    meta: {
        callback: (() => any) | undefined;
    };
};
export declare const push: (routerKey: string, location: string | IPartialLocation<any>, callback?: (() => any) | undefined) => {
    type: AppActionType.PUSH;
    payload: {
        routerKey: string;
        location: string | IPartialLocation<any>;
    };
    meta: {
        callback: (() => any) | undefined;
    };
};
export declare const go: (routerKey: string, n: number, callback?: (() => any) | undefined) => {
    type: AppActionType.GO;
    payload: {
        routerKey: string;
        n: number;
    };
    meta: {
        callback: (() => any) | undefined;
    };
};
export declare const reset: (routerKey: string, entries: (string | IPartialLocation<any>)[], index?: number | undefined, callback?: (() => any) | undefined) => {
    type: AppActionType.RESET;
    payload: {
        routerKey: string;
        entries: (string | IPartialLocation<any>)[];
        index: number | undefined;
    };
    meta: {
        callback: (() => any) | undefined;
    };
};
export declare const goBack: (routerKey: string, callback?: (() => any) | undefined) => {
    type: AppActionType.GO_BACK;
    payload: {
        routerKey: string;
    };
    meta: {
        callback: (() => any) | undefined;
    };
};
export declare const goForward: (routerKey: string, callback?: (() => any) | undefined) => {
    type: AppActionType.GO_FORWARD;
    payload: {
        routerKey: string;
    };
    meta: {
        callback: (() => any) | undefined;
    };
};
export declare const replace: (routerKey: string, location: string | IPartialLocation<any>, callback?: (() => any) | undefined) => {
    type: AppActionType.REPLACE;
    payload: {
        routerKey: string;
        location: string | IPartialLocation<any>;
    };
    meta: {
        callback: (() => any) | undefined;
    };
};
export declare const addModal: (location: string | IPartialLocation<any>, callback?: ((modal: IModal<import("react").ReactElement<any, string | ((props: any) => import("react").ReactElement<any, string | any | (new (props: any) => import("react").Component<any, any, any>)> | null) | (new (props: any) => import("react").Component<any, any, any>)> | import("react").ComponentClass<any, any> | import("react").FunctionComponent<any>>) => any) | undefined) => {
    type: AppActionType.ADD_MODAL;
    payload: {
        location: string | IPartialLocation<any>;
    };
    meta: {
        callback: ((modal: IModal<import("react").ReactElement<any, string | ((props: any) => import("react").ReactElement<any, string | any | (new (props: any) => import("react").Component<any, any, any>)> | null) | (new (props: any) => import("react").Component<any, any, any>)> | import("react").ComponentClass<any, any> | import("react").FunctionComponent<any>>) => any) | undefined;
    };
};
export declare const removeModal: (modalKey: string, callback?: (() => any) | undefined) => {
    type: AppActionType.REMOVE_MODAL;
    payload: {
        modalKey: string;
    };
    meta: {
        callback: (() => any) | undefined;
    };
};
export declare type InternalAppAction = TSActionType<{
    locationChange: typeof routerLocationChange;
}>;
export declare type AppAction = TSActionType<{
    switchTab: typeof switchTab;
    push: typeof push;
    go: typeof go;
    reset: typeof reset;
    goBack: typeof goBack;
    goForward: typeof goForward;
    replace: typeof replace;
    addModal: typeof addModal;
    removeModal: typeof removeModal;
}>;
