import { action as tsAction } from 'typesafe-actions';
export var InternalAppActionType;
(function (InternalAppActionType) {
    InternalAppActionType["ROUTER_LOCATION_CHANGE"] = "@@router/ROUTER_LOCATION_CHANGE";
})(InternalAppActionType || (InternalAppActionType = {}));
export var AppActionType;
(function (AppActionType) {
    AppActionType["SWITCH_TAB"] = "@@router/SWITCH_TAB";
    AppActionType["PUSH"] = "@@router/PUSH";
    AppActionType["GO"] = "@@router/GO";
    AppActionType["RESET"] = "@@router/RESET";
    AppActionType["GO_BACK"] = "@@router/GO_BACK";
    AppActionType["GO_FORWARD"] = "@@router/GO_FORWARD";
    AppActionType["REPLACE"] = "@@router/REPLACE";
    AppActionType["ADD_MODAL"] = "@@router/ADD_MODAL";
    AppActionType["REMOVE_MODAL"] = "@@router/REMOVE_MODAL";
})(AppActionType || (AppActionType = {}));
export const routerLocationChange = (routerKey, action, index, entries, length, location, callback) => tsAction(InternalAppActionType.ROUTER_LOCATION_CHANGE, { routerKey, action, index, entries, length, location }, { callback });
export const switchTab = (location, callback) => tsAction(AppActionType.SWITCH_TAB, { location }, { callback });
export const push = (routerKey, location, callback) => tsAction(AppActionType.PUSH, { routerKey, location }, { callback });
export const go = (routerKey, n, callback) => tsAction(AppActionType.GO, { routerKey, n }, { callback });
export const reset = (routerKey, entries, index, callback) => tsAction(AppActionType.RESET, { routerKey, entries, index }, { callback });
export const goBack = (routerKey, callback) => tsAction(AppActionType.GO_BACK, { routerKey }, { callback });
export const goForward = (routerKey, callback) => tsAction(AppActionType.GO_FORWARD, { routerKey }, { callback });
export const replace = (routerKey, location, callback) => tsAction(AppActionType.REPLACE, { routerKey, location }, { callback });
export const addModal = (location, callback) => tsAction(AppActionType.ADD_MODAL, { location }, { callback });
export const removeModal = (modalKey, callback) => tsAction(AppActionType.REMOVE_MODAL, { modalKey }, { callback });
