/// <reference types="react" />
import { IApp, IPartialLocation } from 'react-native-stack';
import { AnyAction, Dispatch } from 'redux';
import { AppActionType } from '../actions';
export declare function appMiddleware(app: IApp): () => (next: Dispatch<AnyAction>) => (action: {
    type: AppActionType.SWITCH_TAB;
    payload: {
        location: string | IPartialLocation<any>;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: AppActionType.PUSH;
    payload: {
        routerKey: string;
        location: string | IPartialLocation<any>;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: AppActionType.GO;
    payload: {
        routerKey: string;
        n: number;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: AppActionType.RESET;
    payload: {
        routerKey: string;
        entries: (string | IPartialLocation<any>)[];
        index: number | undefined;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: AppActionType.GO_BACK;
    payload: {
        routerKey: string;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: AppActionType.GO_FORWARD;
    payload: {
        routerKey: string;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: AppActionType.REPLACE;
    payload: {
        routerKey: string;
        location: string | IPartialLocation<any>;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: AppActionType.ADD_MODAL;
    payload: {
        location: string | IPartialLocation<any>;
    };
    meta: {
        callback: ((modal: import("react-native-stack").IModal<import("react").ReactElement<any, string | ((props: any) => import("react").ReactElement<any, string | any | (new (props: any) => import("react").Component<any, any, any>)> | null) | (new (props: any) => import("react").Component<any, any, any>)> | import("react").ComponentClass<any, any> | import("react").FunctionComponent<any>>) => any) | undefined;
    };
} | {
    type: AppActionType.REMOVE_MODAL;
    payload: {
        modalKey: string;
    };
    meta: {
        callback: (() => any) | undefined;
    };
}) => undefined;
