import { AppActionType } from '../actions';
export function appMiddleware(app) {
    return () => (next) => (action) => {
        switch (action.type) {
            case AppActionType.SWITCH_TAB:
                // TODO: app.switchTab(action.payload.location)
                return;
            case AppActionType.PUSH:
                if (app.routers[action.payload.routerKey]) {
                    app.routers[action.payload.routerKey].push(action.payload
                        .location);
                }
                return;
            case AppActionType.GO:
                if (app.routers[action.payload.routerKey]) {
                    app.routers[action.payload.routerKey].go(action.payload.n);
                }
                return;
            case AppActionType.RESET:
                if (app.routers[action.payload.routerKey]) {
                    app.routers[action.payload.routerKey].reset(action.payload
                        .entries);
                }
                return;
            case AppActionType.GO_BACK:
                if (app.routers[action.payload.routerKey]) {
                    app.routers[action.payload.routerKey].goBack();
                }
                return;
            case AppActionType.GO_FORWARD:
                if (app.routers[action.payload.routerKey]) {
                    app.routers[action.payload.routerKey].goForward();
                }
                return;
            case AppActionType.REPLACE:
                if (app.routers[action.payload.routerKey]) {
                    app.routers[action.payload.routerKey].replace(action.payload
                        .location);
                }
                return;
            case AppActionType.ADD_MODAL:
                app.addModal(action.payload.location);
                return;
            case AppActionType.REMOVE_MODAL:
                app.removeModal(action.payload.modalKey);
                return;
        }
        return next(action);
    };
}
